--- main/manager.c	2007-07-20 23:54:10.000000000 +0400
+++ main/manager.c	2007-09-17 12:34:29.000000000 +0400
@@ -567,8 +567,8 @@
 	return RESULT_SUCCESS;
 }
 
-/*! \brief CLI command show manager connected */
-/* Should change to "manager show connected" */
+/*! \brief CLI command show manager eventq */
+/* Should change to "manager show eventq" */
 static int handle_showmaneventq(int fd, int argc, char *argv[])
 {
 	struct eventqent *s;
@@ -683,10 +683,12 @@
 {
 	AST_LIST_LOCK(&sessions);
 	AST_LIST_REMOVE(&sessions, s, list);
-	AST_LIST_UNLOCK(&sessions);
-
-	ast_atomic_fetchadd_int(&num_sessions, -1);
+	if (num_sessions)
+	{
+		num_sessions=num_sessions-1;
+	};
 	free_session(s);
+	AST_LIST_UNLOCK(&sessions);
 }
 
 const char *astman_get_header(const struct message *m, char *var)
@@ -2235,6 +2237,10 @@
 		AST_LIST_TRAVERSE_SAFE_BEGIN(&sessions, s, list) {
 			if (s->sessiontimeout && (now > s->sessiontimeout) && !s->inuse) {
 				AST_LIST_REMOVE_CURRENT(&sessions, list);
+				if (num_sessions)
+				{
+					num_sessions=num_sessions-1;
+				};
 				if (s->authenticated && (option_verbose > 1) && displayconnects) {
 					ast_verbose(VERBOSE_PREFIX_2 "HTTP Manager '%s' timed out from %s\n",
 						s->username, ast_inet_ntoa(s->sin.sin_addr));
@@ -2253,8 +2259,6 @@
 			free(eqe);
 		}
 		AST_LIST_UNLOCK(&sessions);
-		if (s)
-			ast_atomic_fetchadd_int(&num_sessions, -1);
 
 		sinlen = sizeof(sin);
 		pfds[0].fd = asock;
@@ -2277,8 +2281,6 @@
 		if (!(s = ast_calloc(1, sizeof(*s))))
 			continue;
 
-		ast_atomic_fetchadd_int(&num_sessions, 1);
-		
 		memcpy(&s->sin, &sin, sizeof(sin));
 		s->writetimeout = 100;
 		s->waiting_thread = AST_PTHREADT_NULL;
@@ -2296,13 +2298,16 @@
 		s->send_events = -1;
 		AST_LIST_LOCK(&sessions);
 		AST_LIST_INSERT_HEAD(&sessions, s, list);
+		num_sessions+=1;
 		/* Find the last place in the master event queue and hook ourselves
 		   in there */
 		s->eventq = master_eventq;
 		while(s->eventq->next)
 			s->eventq = s->eventq->next;
 		AST_LIST_UNLOCK(&sessions);
+
 		ast_atomic_fetchadd_int(&s->eventq->usecount, 1);
+
 		if (ast_pthread_create_background(&s->t, &attr, session_do, s))
 			destroy_session(s);
 	}
@@ -2576,13 +2581,13 @@
 		s->managerid = rand() | (unsigned long)s;
 		AST_LIST_LOCK(&sessions);
 		AST_LIST_INSERT_HEAD(&sessions, s, list);
+		num_sessions+=1;
 		/* Hook into the last spot in the event queue */
 		s->eventq = master_eventq;
 		while (s->eventq->next)
 			s->eventq = s->eventq->next;
 		AST_LIST_UNLOCK(&sessions);
 		ast_atomic_fetchadd_int(&s->eventq->usecount, 1);
-		ast_atomic_fetchadd_int(&num_sessions, 1);
 	}
 
 	/* Reset HTTP timeout.  If we're not yet authenticated, keep it extremely short */
